package com.wzhang.spring.test;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.wzhang.springdemo.domain.Customer;
import com.wzhang.springdemo.service.CustomerService;

public class HibernateTest {
	
	static ApplicationContext ctx =null;
	static{
		ctx = new ClassPathXmlApplicationContext(
				"classpath:spring/applicationContext.xml");
	}
	

	/**
	 * 测试正常保存
	 */
	@Test
	public void bathSaveTest() {
		CustomerService service = (CustomerService) ctx
				.getBean("customerService");
		List<Customer> list = new ArrayList<Customer>();
		for (int i = 0; i < 3; i++) {
			Customer c = new Customer();
			c.setAge(10 + i * 10);
			c.setName("张三");
			list.add(c);
		}
		service.saveCustomers(list);
	}

	/**
	 * 测试事务是否回滚
	 */
	@Test
	public void transactionTest() {
		CustomerService service = (CustomerService) ctx
				.getBean("customerService");
		List<Customer> list = new ArrayList<Customer>();
		for (int i = 0; i < 3; i++) {
			Customer c = new Customer();
			if (i == 2) {//i=2时设置name为空，测试事务是否回滚
				c.setAge(10 + i * 10);
				c.setName(null);
			} else {
				c.setAge(10 + i * 10);
				c.setName("张三");
			}
			list.add(c);
		}
		service.saveCustomers(list);
	}

}
